# Record Class StDeviceKey

java.lang.Object
java.lang.Record
com.io7m.stonesignal.server.devices.StDeviceKey

Record Components:
  `key` - The device key

public record StDeviceKey(String key) extends Record
A device key.

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final Pattern`
  `VALID_KEY`
  The pattern that defines a valid key.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `StDeviceKey(String key)`
  A device key.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `final boolean`
  `equals(Object o)`
  Indicates whether some other object is "equal to" this one.
  `final int`
  `hashCode()`
  Returns a hash code value for this object.
  `String`
  `key()`
  Returns the value of the `key` record component.
  `static StDeviceKey`
  `random()`
  `static StDeviceKey`
  `redactedKey()`
  `final String`
  `toString()`
  Returns a string representation of this record class.

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Field Details

  - ### VALID_KEY

    public static final Pattern VALID_KEY
    The pattern that defines a valid key.

- ## Constructor Details

  - ### StDeviceKey

    public StDeviceKey(String key)
    A device key.
    Parameters:
      `key` - The device key

- ## Method Details

  - ### random

    public static StDeviceKey random()
    Returns:
      A strong random device key

  - ### redactedKey

    public static StDeviceKey redactedKey()
    Returns:
      A redacted key

  - ### toString

    public final String toString()
    Returns a string representation of this record class. The representation contains the name of the class, followed by the name and value of each of the record components.
    Specified by:
      `toString` in class `Record`
    Returns:
      a string representation of this object

  - ### hashCode

    public final int hashCode()
    Returns a hash code value for this object. The value is derived from the hash code of each of the record components.
    Specified by:
      `hashCode` in class `Record`
    Returns:
      a hash code value for this object

  - ### equals

    public final boolean equals(Object o)
    Indicates whether some other object is "equal to" this one. The objects are equal if the other object is of the same class and if all the record components are equal. All components in this record class are compared with `Objects::equals(Object,Object)`.
    Specified by:
      `equals` in class `Record`
    Parameters:
      `o` - the object with which to compare
    Returns:
      `true` if this object is the same as the `o` argument; `false` otherwise.

  - ### key

    public String key()
    Returns the value of the `key` record component.
    Returns:
      the value of the `key` record component